'Copyright (c) 2022 keybonicPlague (Keybone)

'$DYNAMIC
Option _Explicit

'$include:'default-theme.bi'

_Title "OS/3"

Type aCursor
    pX As Integer
    pY As Integer
    lB As _Byte
    mB As _Byte
    rB As _Byte
End Type
Type aWindow
    pX As Integer
    pY As Integer
    sX As _Unsigned Integer
    sY As _Unsigned Integer
    Img As _Unsigned Long
End Type

Type aStatus
    Restored As _Byte
    Minimized As _Byte
    Active As _Byte
End Type

Type anIcon
    pX As Integer
    pY As Integer
    sX As _Unsigned Integer
    sY As _Unsigned Integer
    Img As _Unsigned Long
End Type

Type anObject
    ID As _Unsigned Long
    Title As String
    Shortcut As _Byte
    ShellCMD As String
    Win As aWindow
    Icon As anIcon
    Status As aStatus
End Type

Dim Shared arraySize As _Unsigned Long
ReDim Shared O(arraySize) As anObject

Dim Shared Mouse As aCursor

Dim Shared Desktop As _Unsigned Long

Dim fullscreenMode As _Bit
Dim scaledMode As _Bit

' User Code Below

fullscreenMode = -1
scaledMode = 0
Desktop = _NewImage(_DesktopWidth, _DesktopHeight, 32)

initShortcut "xterm", "blank.png", "exo-open --launch TerminalEmulator &", 100, 100, 32, 32
initShortcut "mate-calc", "blank.png", "mate-calc &", 100, 200, 32, 32
initShortcut "mousepad", "blank.png", "mousepad &", 100, 300, 32, 32
initShortcut "thunar", "blank.png", "thunar &", 100, 400, 32, 32
initShortcut "firefox", "blank.png", "firefox &", 200, 100, 32, 32
initShortcut "mines", "blank.png", "gnome-mines &", 200, 200, 32, 32
initShortcut "gimp", "blank.png", "gimp &", 200, 300, 32, 32
initShortcut "Home", "folder.png", "thunar ~ &", 200, 400, 32, 32
initShortcut "Desktop", "folder.png", "thunar ~/Desktop &", 200, 500, 32, 32
initShortcut "Downloads", "folder.png", "thunar ~/Downloads &", 200, 600, 32, 32

initObject "Exit OS/3"
initWindow 200, 200, 300, 300
initIcon "./exit.png", 100, (_Height - 100), 32, 32

initObject "Mine"
initWindow 200, 200, 160, 180
initIcon "./mines.png", 200, (_Height - 100), 32, 32

initObject "About"
initWindow 100, 150, 340, 200
initIcon "./progman.png", 300, (_Height - 100), 32, 32

initObject "Display"
initWindow 200, 200, 205, 285
initIcon "./displayprop.png", 400, (_Height - 100), 32, 32

'User Code Above

Screen Desktop: _PrintMode _KeepBackground

If fullscreenMode Then
    If scaledMode Then
        _FullScreen _Stretch , _Smooth

    Else
        _FullScreen _SquarePixels , _Smooth
    End If
End If

Dim I As _Unsigned Long: While arraySize > 0
    placeBackground
    probeMouse
    For I = arraySize To 1 Step -1
        If Mouse.lB Then
            If isWithinWindow(I) Then
                If O(I).Status.Minimized Then
                    moveIcon (I)
                    _Delay 0.125
                    Exit For
                ElseIf O(I).Status.Restored Then
                    raiseToTop (I)
                    If isWithinArea(I, 5, 4, O(I).Win.sX - 42, 21) Then
                        moveWindow (I)
                        _Delay 0.125
                        Exit For
                    ElseIf isWithinArea(I, O(I).Win.sX - 22, 4, O(I).Win.sX - 5, 21) Then
                        minimizeWindow (I)
                        If I > 1 Then raiseToTop (I - 1)
                        _Delay 0.125
                        Exit For
                    End If
                End If
                Exit For
            End If
        End If
    Next I
    updateDisplay
    _Display
    '_Limit 60
Wend: System

Sub probeMouse
    Dim i As Integer: While _MouseInput
        i = _MouseInput
    Wend
    Mouse.lB = _MouseButton(1)
    Mouse.rB = _MouseButton(2)
    Mouse.pX = _MouseX
    Mouse.pY = _MouseY
End Sub

Function isWithinWindow%% (ID As _Unsigned Long)
    isWithinWindow = 0
    If O(ID).Status.Restored = -1 Then
        If Mouse.pX >= O(ID).Win.pX Then
            If Mouse.pY >= O(ID).Win.pY Then
                If Mouse.pX <= O(ID).Win.pX + O(ID).Win.sX Then
                    If Mouse.pY <= O(ID).Win.pY + O(ID).Win.sY Then
                        isWithinWindow = -1
                    End If
                End If
            End If
        End If
    ElseIf O(ID).Status.Minimized = -1 Then
        If Mouse.pX >= O(ID).Icon.pX Then
            If Mouse.pY >= O(ID).Icon.pY Then
                If Mouse.pX <= O(ID).Icon.pX + O(ID).Icon.sX Then
                    If Mouse.pY <= O(ID).Icon.pY + O(ID).Icon.sY Then
                        isWithinWindow = -1
                    End If
                End If
            End If
        End If
    End If
End Function

Function isWithinArea%% (ID As _Unsigned Long, startX As _Unsigned Integer, startY As _Unsigned Integer, endX As _Unsigned Integer, endY As _Unsigned Integer)
    If O(ID).Status.Restored = -1 Then
        If Mouse.pX >= (O(ID).Win.pX + startX) Then
            If Mouse.pY >= (O(ID).Win.pY + startY) Then
                If Mouse.pX <= (O(ID).Win.pX + endX) Then
                    If Mouse.pY <= (O(ID).Win.pY + endY) Then
                        isWithinArea = -1
                    End If
                End If
            End If
        End If
    End If
End Function

Sub addToZOrder
    arraySize = arraySize + 1
    ReDim _Preserve O(arraySize) As anObject
End Sub

Sub removeFromZOrder (ID As _Unsigned Long)
    Dim I As _Unsigned _Integer64
    For I = ID To arraySize
        If I < arraySize Then O(I) = O(I + 1)
    Next I
    If arraySize > 0 Then
        arraySize = arraySize - 1
        ReDim _Preserve O(arraySize) As anObject
    End If
End Sub

Sub raiseToTop (ID As _Unsigned Long)
    Dim Tmp As anObject
    Dim I As _Integer64
    For I = 1 To arraySize
        O(I).Status.Active = 0
        drawWindow (I)
    Next I
    Tmp = O(ID)
    For I = ID To arraySize
        If I >= ID And I < arraySize Then O(I) = O(I + 1)
    Next I
    O(arraySize) = Tmp
    makeActive
End Sub

Sub makeActive
    Dim I As _Integer64
    For I = 1 To arraySize
        O(I).Status.Active = 0
        drawWindow (I)
    Next I
    O(arraySize).Status.Active = -1
    drawWindow (arraySize)
End Sub

Sub drawWindow (ID As _Unsigned Long)
    _Dest O(ID).Win.Img
    _PrintMode _KeepBackground
    If O(ID).Status.Active = -1 Then
        Color white
    Else
        Color black
    End If
    Dim temp As Integer
    Dim Centering As _Unsigned Integer
    If O(ID).Status.Restored = -1 Then
        Line (0, 0)-(O(ID).Win.sX - 1, O(ID).Win.sY - 1), black, B
        Line (1, 1)-(O(ID).Win.sX - 2, O(ID).Win.sY - 2), highlight2, B
        Line (2, 2)-(O(ID).Win.sX - 2, O(ID).Win.sY - 2), shadow2, B
        Line (2, 2)-(O(ID).Win.sX - 3, O(ID).Win.sY - 3), highlight, B
        Line (3, 3)-(O(ID).Win.sX - 3, O(ID).Win.sY - 3), shadow, B
        Line (3, 3)-(O(ID).Win.sX - 4, O(ID).Win.sY - 4), black, B
        Line (0, O(ID).Win.sY - 23)-(3, O(ID).Win.sY - 23), black
        Line (23, O(ID).Win.sY - 3)-(23, O(ID).Win.sY), black
        Line (O(ID).Win.sX, O(ID).Win.sY - 23)-(O(ID).Win.sX - 3, O(ID).Win.sY - 23), black
        Line (O(ID).Win.sX - 23, O(ID).Win.sY - 3)-(O(ID).Win.sX - 23, O(ID).Win.sY), black
        Line (4, 4)-(O(ID).Win.sX - 5, O(ID).Win.sY - 5), windowBackground, BF
        If O(ID).Status.Active = -1 Then
            Line (4, 4)-(O(ID).Win.sX - 6, 21), activeTitlebar, BF
        Else
            Line (4, 4)-(O(ID).Win.sX - 6, 21), inactiveTitlebar, BF
        End If
        Line (O(ID).Win.sX - 23, 0)-(O(ID).Win.sX - 1, 22), black, B
        Line (0, 22)-(O(ID).Win.sX - 1, 22), black
        temp = _PrintWidth(LTrim$(RTrim$(O(ID).Title)))
        Centering = (O(ID).Win.sX - (60 + temp)) / 2
        _PrintString (Centering + 20, 5), O(ID).Title
        Call displayButton(O(ID).Win.sX - 22, 4, O(ID).Win.sX - 5, 21, 1)
    End If
    _Dest Desktop
End Sub

Sub displayButton (sX As _Unsigned Integer, sY As _Unsigned Integer, eX As _Unsigned Integer, eY As _Unsigned Integer, T As _Unsigned _Byte)
    Line (sX, sY)-(eX, eY), shadow2, B
    Line (sX, sY)-(eX - 1, eY - 1), highlight, B
    Line (sX + 1, sY + 1)-(eX - 1, eY - 1), shadow2, B
    Line (sX + 1, sY + 1)-(eX - 2, eY - 2), highlight, B
    Line (sX + 2, sY + 2)-(eX - 2, eY - 2), face, BF
    Select Case T
        Case 0
        Case 1
            Line (sX + 5, sY + 7)-(sX + 11, sY + 7), black
            Line (sX + 6, sY + 8)-(sX + 10, sY + 8), black
            Line (sX + 7, sY + 9)-(sX + 9, sY + 9), black
            Line (sX + 8, sY + 10)-(sX + 8, sY + 10), black
    End Select
End Sub

Sub updateDisplay
    Dim I As _Unsigned Long
    Dim Tmp As _Unsigned Integer
    Dim temp As Integer, temp1 As Integer, temp2 As Integer
    For I = 1 To arraySize
        If O(I).Status.Minimized = -1 Then
            _PutImage (O(I).Icon.pX, O(I).Icon.pY), O(I).Icon.Img
            temp = _PrintWidth(LTrim$(RTrim$(O(I).Title)))
            Tmp = (temp - O(I).Icon.sX) / 2
            temp1 = (O(I).Icon.pX - Tmp + 2)
            temp2 = ((O(I).Icon.pY + O(I).Icon.sY) + 6)
            Line ((O(I).Icon.pX - Tmp), (O(I).Icon.pY + O(I).Icon.sY) + 5)-(((O(I).Icon.pX - Tmp) + (temp) + 2), (O(I).Icon.pY + O(I).Icon.sY) + 20), white, BF
            Line ((O(I).Icon.pX - Tmp), (O(I).Icon.pY + O(I).Icon.sY) + 5)-(((O(I).Icon.pX - Tmp) + (temp) + 2), (O(I).Icon.pY + O(I).Icon.sY) + 20), black, B
            Line ((O(I).Icon.pX - Tmp), (O(I).Icon.pY + O(I).Icon.sY) + 5)-(((O(I).Icon.pX - Tmp) + (temp) + 2), (O(I).Icon.pY + O(I).Icon.sY) + 20), activeTitlebar, BF
            Color black
            _PrintString (temp1, temp2), O(I).Title
        ElseIf O(I).Status.Restored = -1 Then
            Line (O(I).Win.pX + shadowDepth, O(I).Win.pY + shadowDepth)-((O(I).Win.pX + O(I).Win.sX) + shadowDepth, (O(I).Win.pY + O(I).Win.sY) + shadowDepth), windowShadow, BF
            _PutImage (O(I).Win.pX, O(I).Win.pY), O(I).Win.Img
        End If
    Next I
End Sub

Sub minimizeWindow (ID As _Unsigned Long)
    If O(ID).Status.Restored = -1 Then
        O(ID).Status.Restored = 0
    End If
    O(ID).Status.Minimized = -1
End Sub

Sub restoreWindow (ID As _Unsigned Long)
    If O(ID).Status.Minimized = -1 Then
        O(ID).Status.Minimized = 0
        O(ID).Status.Restored = -1
    End If
    raiseToTop (ID)
End Sub

Sub moveWindow (ID As _Unsigned Long)
    If O(ID).Status.Restored = -1 And O(ID).Status.Minimized = 0 Then
        Dim temp1 As _Unsigned Integer, temp2 As _Unsigned Integer
        temp1 = (O(ID).Win.pX - Mouse.pX)
        temp2 = (O(ID).Win.pY - Mouse.pY)
        While Mouse.lB
            placeBackground
            probeMouse
            O(ID).Win.pX = (Mouse.pX + temp1)
            O(ID).Win.pY = (Mouse.pY + temp2)
            updateDisplay
            _Display
        Wend
    End If
End Sub

Sub moveIcon (ID As _Unsigned Long)
    If O(ID).Status.Minimized = -1 And O(ID).Status.Restored = 0 Then
        Dim temporaryIconStartX As _Unsigned Integer, temporaryIconStartY As _Unsigned Integer
        Dim temp1 As _Unsigned Integer, temp2 As _Unsigned Integer
        Dim previousMouseX As _Unsigned Integer, previousMouseY As _Unsigned Integer
        Dim currentMouseX As _Unsigned Integer, currentMouseY As _Unsigned Integer
        temporaryIconStartX = O(ID).Icon.pX
        temporaryIconStartY = O(ID).Icon.pY
        temp1 = (O(ID).Icon.pX - Mouse.pX)
        temp2 = (O(ID).Icon.pY - Mouse.pY)
        While Mouse.lB
            previousMouseX = Mouse.pX: previousMouseY = Mouse.pY
            probeMouse
            currentMouseX = Mouse.pX: currentMouseY = Mouse.pY
            If currentMouseX <> previousMouseX Or currentMouseY <> previousMouseY Then
                O(ID).Icon.pX = (Mouse.pX + temp1)
                O(ID).Icon.pY = (Mouse.pY + temp2)
                placeBackground
                updateDisplay
                _Display
            End If
        Wend
        If temporaryIconStartX = O(ID).Icon.pX Then
            If temporaryIconStartY = O(ID).Icon.pY Then
                If O(ID).Shortcut = 0 Then
                    restoreWindow (ID)
                ElseIf O(ID).Shortcut = -1 Then
                    Shell O(ID).ShellCMD
                End If
            End If
        End If
    End If
End Sub

Sub initObject (T As String)
    addToZOrder
    O(arraySize).ID = arraySize
    O(arraySize).Title = LTrim$(RTrim$(T))
    O(arraySize).Status.Restored = 0
    O(arraySize).Status.Minimized = -1
    O(arraySize).Status.Active = 0
End Sub

Sub initWindow (X As Integer, Y As Integer, W As _Unsigned Integer, H As _Unsigned Integer)
    O(arraySize).Win.pX = X
    O(arraySize).Win.pY = Y
    O(arraySize).Win.sX = W
    O(arraySize).Win.sY = H
    O(arraySize).Win.Img = _NewImage(O(arraySize).Win.sX, O(arraySize).Win.sY, 32)
    drawWindow (arraySize)
End Sub

Sub initIcon (Filename As String, X As Integer, Y As Integer, W As _Unsigned Integer, H As _Unsigned Integer)
    O(arraySize).Icon.pX = X
    O(arraySize).Icon.pY = Y
    O(arraySize).Icon.sX = W
    O(arraySize).Icon.sY = H
    O(arraySize).Icon.Img = _LoadImage(LTrim$(RTrim$(Filename)))
End Sub

Sub initShortcut (T As String, Filename As String, shellCMD As String, X As Integer, Y As Integer, W As _Unsigned Integer, H As _Unsigned Integer)
    initObject (T)
    initWindow X, Y, W, H
    initIcon LTrim$(RTrim$(Filename)), X, Y, W, H
    O(arraySize).Shortcut = -1
    O(arraySize).ShellCMD = shellCMD
End Sub

Sub initializeBackground (Filename As String, backgroundOptions As String)
    backgroundOptions = UCase$(backgroundOptions)
    If _FileExists(Filename) Then
        Static oldFilename As String
        If Filename <> oldFilename Then
            Static backgroundHandle As Long
            backgroundHandle = _LoadImage(Filename, 32)
        End If
        Select Case backgroundOptions
            Case "RAW"
                _PutImage (0, 0)-(_Width, _Height), backgroundHandle, 0, (0, 0)-(_Width, _Height)
            Case "SCALED"
                _PutImage , backgroundHandle, 0
            Case "TILED"
                Dim tileWidth As _Unsigned Integer: tileWidth = _Width(backgroundHandle)
                Dim tileHeight As _Unsigned Integer: tileHeight = _Height(backgroundHandle)
                Dim numberWide As Single: numberWide = _Width \ tileWidth
                Dim numberHigh As Single: numberHigh = _Height \ tileHeight
                Dim currentDesktopHigh As _Unsigned Integer
                Dim currentDesktopWide As _Unsigned Integer
                For currentDesktopHigh = 0 To numberHigh
                    For currentDesktopWide = 0 To numberWide
                        _PutImage (tileWidth * currentDesktopWide, tileHeight * currentDesktopHigh), backgroundHandle, 0
                    Next currentDesktopWide
                Next currentDesktopHigh
        End Select
        oldFilename = Filename
    Else
        Print "ERROR: Invalid Filename!": Beep
    End If
End Sub

Sub placeBackground
    initializeBackground "Gold Weave.bmp", "TILED"
End Sub

